# Class InflaterInputStream

java.lang.Object
java.io.InputStream
com.codename1.io.gzip.FilterInputStream
com.codename1.io.gzip.InflaterInputStream

All Implemented Interfaces:
  `AutoCloseable`

Direct Known Subclasses:
  `GZIPInputStream`

public class InflaterInputStream extends FilterInputStream

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected byte[]`
  `buf`
  `protected static final int`
  `DEFAULT_BUFSIZE`
  `protected final Inflater`
  `inflater`
  `protected boolean`
  `myinflater`

  ### Fields inherited from class FilterInputStream

  `in`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `InflaterInputStream(InputStream in)`
  `InflaterInputStream(InputStream in, boolean nowrap)`
  `InflaterInputStream(InputStream in, Inflater inflater)`
  `InflaterInputStream(InputStream in, Inflater inflater, int size)`
  `InflaterInputStream(InputStream in, Inflater inflater, int size, boolean closeIn)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `available()`
  Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream.
  `void`
  `close()`
  Closes this input stream and releases any system resources associated with the stream.
  `protected void`
  `fill()`
  `byte[]`
  `getAvailIn()`
  `Inflater`
  `getInflater()`
  `long`
  `getTotalIn()`
  `long`
  `getTotalOut()`
  `void`
  `mark(int readlimit)`
  Marks the current position in this input stream.
  `boolean`
  `markSupported()`
  Tests if this input stream supports the mark and reset methods.
  `int`
  `read()`
  Reads the next byte of data from the input stream.
  `int`
  `read(byte[] b, int off, int len)`
  Reads up to len bytes of data from the input stream into an array of bytes.
  `void`
  `readHeader()`
  `void`
  `reset()`
  Repositions this stream to the position at the time the mark method was last called on this input stream.
  `long`
  `skip(long n)`
  Skips over and discards n bytes of data from this input stream.

  ### Methods inherited from class FilterInputStream

  `read`

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_BUFSIZE

    protected static final int DEFAULT_BUFSIZE
    See Also:
      - Constant Field Values

  - ### inflater

    protected final Inflater inflater

  - ### buf

    protected byte[] buf

  - ### myinflater

    protected boolean myinflater

- ## Constructor Details

  - ### InflaterInputStream

    public InflaterInputStream(InputStream in) throws IOException
    Throws:
      `IOException`

  - ### InflaterInputStream

    public InflaterInputStream(InputStream in, boolean nowrap) throws IOException
    Throws:
      `IOException`

  - ### InflaterInputStream

    public InflaterInputStream(InputStream in, Inflater inflater) throws IOException
    Throws:
      `IOException`

  - ### InflaterInputStream

    public InflaterInputStream(InputStream in, Inflater inflater, int size) throws IOException
    Throws:
      `IOException`

  - ### InflaterInputStream

    public InflaterInputStream(InputStream in, Inflater inflater, int size, boolean closeIn) throws IOException
    Throws:
      `IOException`

- ## Method Details

  - ### read

    public int read() throws IOException
    Description copied from class: `InputStream`
    Reads the next byte of data from the input stream. The value byte is returned as an int in the range 0 to 255. If no byte is available because the end of the stream has been reached, the value -1 is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown. A subclass must provide an implementation of this method.
    Overrides:
      `read` in class `FilterInputStream`
    Throws:
      `IOException`

  - ### read

    public int read(byte[] b, int off, int len) throws IOException
    Description copied from class: `InputStream`

    Reads up to len bytes of data from the input stream into an array of bytes. An attempt is made to read as many as len bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer. This method blocks until input data is available, end of file is detected, or an exception is thrown. If b is null, a NullPointerException is thrown. If off is negative, or len is negative, or off+len is greater than the length of the array b, then an IndexOutOfBoundsException is thrown. If len is zero, then no bytes are read and 0 is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value -1 is returned; otherwise, at least one byte is read and stored into b. The first byte read is stored into element b

    invalid reference

        off

    , the next one into b[off+1], and so on. The number of bytes read is, at most, equal to len. Let k be the number of bytes actually read; these bytes will be stored in elements b
    invalid reference

        off

    through b[off+k-1], leaving elements b[off+k] through b[off+len-1] unaffected.

    In every case, elements b[0] through b

    invalid reference

        off

    and elements b[off+len] through b[b.length-1] are unaffected.

    If the first byte cannot be read for any reason other than end of file, then an IOException is thrown. In particular, an IOException is thrown if the input stream has been closed. The read(b, off, len) method for class InputStream simply calls the method read() repeatedly. If the first such call results in an IOException, that exception is returned from the call to the read(b, off, len) method. If any subsequent call to read() results in a IOException, the exception is caught and treated as if it were end of file; the bytes read up to that point are stored into b and the number of bytes read before the exception occurred is returned. Subclasses are encouraged to provide a more efficient implementation of this method.

    Overrides:
      `read` in class `FilterInputStream`
    Throws:
      `IOException`

  - ### available

    public int available() throws IOException
    Description copied from class: `InputStream`
    Returns the number of bytes that can be read (or skipped over) from this input stream without blocking by the next caller of a method for this input stream. The next caller might be the same thread or another thread. The available method for class InputStream always returns 0. This method should be overridden by subclasses.
    Overrides:
      `available` in class `FilterInputStream`
    Throws:
      `IOException`

  - ### skip

    public long skip(long n) throws IOException
    Description copied from class: `InputStream`
    Skips over and discards n bytes of data from this input stream. The skip method may, for a variety of reasons, end up skipping over some smaller number of bytes, possibly 0. This may result from any of a number of conditions; reaching end of file before n bytes have been skipped is only one possibility. The actual number of bytes skipped is returned. If n is negative, no bytes are skipped. The skip method of InputStream creates a byte array and then repeatedly reads into it until n bytes have been read or the end of the stream has been reached. Subclasses are encouraged to provide a more efficient implementation of this method.
    Overrides:
      `skip` in class `FilterInputStream`
    Throws:
      `IOException`

  - ### close

    public void close() throws IOException
    Description copied from class: `InputStream`
    Closes this input stream and releases any system resources associated with the stream. The close method of InputStream does nothing.
    Specified by:
      `close` in interface `AutoCloseable`
    Overrides:
      `close` in class `FilterInputStream`
    Throws:
      `IOException`

  - ### fill

    protected void fill() throws IOException
    Throws:
      `IOException`

  - ### markSupported

    public boolean markSupported()
    Description copied from class: `InputStream`
    Tests if this input stream supports the mark and reset methods. The markSupported method of InputStream returns false.
    Overrides:
      `markSupported` in class `FilterInputStream`

  - ### mark

    public void mark(int readlimit)
    Description copied from class: `InputStream`
    Marks the current position in this input stream. A subsequent call to the reset method repositions this stream at the last marked position so that subsequent reads re-read the same bytes. The readlimit arguments tells this input stream to allow that many bytes to be read before the mark position gets invalidated. The general contract of mark is that, if the method markSupported returns true, the stream somehow remembers all the bytes read after the call to mark and stands ready to supply those same bytes again if and whenever the method reset is called. However, the stream is not required to remember any data at all if more than readlimit bytes are read from the stream before reset is called. The mark method of InputStream does nothing.
    Overrides:
      `mark` in class `FilterInputStream`

  - ### reset

    public void reset() throws IOException
    Description copied from class: `InputStream`
    Repositions this stream to the position at the time the mark method was last called on this input stream. The general contract of reset is: If the method markSupported returns true, then: If the method mark has not been called since the stream was created, or the number of bytes read from the stream since mark was last called is larger than the argument to mark at that last call, then an IOException might be thrown. If such an IOException is not thrown, then the stream is reset to a state such that all the bytes read since the most recent call to mark (or since the start of the file, if mark has not been called) will be resupplied to subsequent callers of the read method, followed by any bytes that otherwise would have been the next input data as of the time of the call to reset. If the method markSupported returns false, then: The call to reset may throw an IOException. If an IOException is not thrown, then the stream is reset to a fixed state that depends on the particular type of the input stream and how it was created. The bytes that will be supplied to subsequent callers of the read method depend on the particular type of the input stream. The method reset for class InputStream does nothing and always throws an IOException.
    Overrides:
      `reset` in class `FilterInputStream`
    Throws:
      `IOException`

  - ### getTotalIn

    public long getTotalIn()

  - ### getTotalOut

    public long getTotalOut()

  - ### getAvailIn

    public byte[] getAvailIn()

  - ### readHeader

    public void readHeader() throws IOException
    Throws:
      `IOException`

  - ### getInflater

    public Inflater getInflater()